"use strict";
/**
 * Copyright Microsoft Corporation. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.stopProfiling = exports.startProfiling = void 0;
const fs = __importStar(require("fs"));
const path = __importStar(require("path"));
const profileDir = process.env.PWTEST_PROFILE_DIR || '';
let session;
async function startProfiling() {
    if (!profileDir)
        return;
    session = new (require('inspector').Session)();
    session.connect();
    await new Promise(f => {
        session.post('Profiler.enable', () => {
            session.post('Profiler.start', f);
        });
    });
}
exports.startProfiling = startProfiling;
async function stopProfiling(workerIndex) {
    if (!profileDir)
        return;
    await new Promise(f => session.post('Profiler.stop', async (err, { profile }) => {
        if (!err) {
            await fs.promises.mkdir(profileDir, { recursive: true });
            await fs.promises.writeFile(path.join(profileDir, workerIndex === undefined ? 'runner.json' : 'worker' + workerIndex + '.json'), JSON.stringify(profile));
        }
        f();
    }));
}
exports.stopProfiling = stopProfiling;
//# sourceMappingURL=profiler.js.map